/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.69 Revision 1.127
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.69 2010/05/24 14:27:13 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.127 2012/05/02 17:09:17 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
21else 45 IUSE+=" +exceptions"
22 MY_P=qt-x11-opensource-src-${MY_PV}
23fi 46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
24 50
25HOMEPAGE="http://qt.nokia.com/" 51DEPEND="virtual/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 52if [[ ${QT4_BUILD_TYPE} == live ]]; then
27 53 DEPEND+=" dev-lang/perl"
28LICENSE="|| ( LGPL-2.1 GPL-3 )" 54fi
29IUSE+=" debug pch aqua"
30 55
31RDEPEND=" 56RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 71 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999 72 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
63 94
64S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
65 96
66# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 98# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
70 if [[ "${PN}" == "qt-webkit" ]]; then
71 if [[ "${CFLAGS}" =~ "-ggdb" ]] || [[ "${CXXFLAGS}" =~ "-ggdb" ]]; then
72 echo
73 ewarn "Your \$C{,XX}FLAGS contain -ggdb. You may experience really"
74 ewarn "long compilation times and/or increased memory usage."
75 ewarn "If compilation fails, please try removing -ggdb before"
76 ewarn "reporting a bug."
77 ewarn "For more info check out bug #307861"
78 echo
79 fi
80 fi
81
82 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
83 102
84 # Protect users by not allowing downgrades between releases 103 # Protect users by not allowing downgrades between releases
85 # Downgrading revisions within the same release should be allowed 104 # Downgrading revisions within the same release should be allowed
86 if has_version '>'${CATEGORY}/${P}-r9999 ; then 105 if has_version '>'${CATEGORY}/${P}-r9999; then
87 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
88 eerror "Sanity check to keep you from breaking your system:" 108 eerror "Sanity check to keep you from breaking your system:"
89 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
90 die "aborting to save your system" 111 die "aborting to save your system"
91 else 112 else
92 ewarn "Downgrading Qt is completely unsupported and will break your system!" 113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
93 fi 114 fi
115 fi
116
117 if [[ ${PN} == qt-webkit ]]; then
118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
126 fi
127 eshopts_pop
94 fi 128 fi
95 129
96 PATH="${S}/bin${PATH:+:}${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
97 if [[ ${CHOST} != *-darwin* ]]; then 131 if [[ ${CHOST} != *-darwin* ]]; then
98 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 [[ ${CHOST} == *-apple-darwin* ]] && \ 138 [[ ${CHOST} == *-apple-darwin* ]] && \
105 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
106 ${QT4_EXTRACT_DIRECTORIES}" 140 ${QT4_EXTRACT_DIRECTORIES}"
107 fi 141 fi
108 142
109 # Make sure ebuilds use the required EAPI
110 if [[ ${EAPI} != [23] ]]; then
111 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
112 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
113 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
114 die "qt4-build eclass requires EAPI=2 or EAPI=3"
115 fi
116
117 if ! version_is_at_least 4.1 $(gcc-version); then 143 if ! version_is_at_least 4.1 $(gcc-version); then
118 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
119 fi 145 fi
120} 146}
121 147
122# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
123# @DESCRIPTION: 149# @DESCRIPTION:
124# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
125# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
126 152
127# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
128# @DESCRIPTION: 154# @DESCRIPTION:
129# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
130# tarball 156# Qt tarball.
131 157
132# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
133# @DESCRIPTION: 159# @DESCRIPTION:
134# Unpacks the sources 160# Unpacks the sources.
135qt4-build_src_unpack() { 161qt4-build_src_unpack() {
136 setqtenv 162 setqtenv
137 local target targets= 163
164 case ${QT4_BUILD_TYPE} in
165 live)
166 git-2_src_unpack
167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
138 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
139 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
140 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
141 targets+=" ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
142 done 175 done
143 176
144 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
181 esac
146} 182}
147 183
148# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
149# @DESCRIPTION: 186# @DESCRIPTION:
150# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
151# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
152# example: 189# Make sure to specify the full path. This variable is utilised in
153# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
154# ${FILESDIR}"/mypatch2.patch"
155# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
156 196
157# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
158# @DESCRIPTION: 198# @DESCRIPTION:
159# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
160# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
161qt4-build_src_prepare() { 201qt4-build_src_prepare() {
162 setqtenv 202 setqtenv
163 cd "${S}"
164 203
165 # fix qt 4.7 regression that skips -fvisibility=hidden 204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
166 if [[ "${PV}" == "4.7.0_beta1" ]]; then 205 QTDIR="." ./bin/syncqt || die "syncqt failed"
167 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 206 fi
168 -i config.tests/unix/fvisibility.test || 207
169 die "visibility fixing sed failed" 208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
170 fi 214 fi
171 215
172 if use aqua; then 216 if use aqua; then
173 # provide a proper macx-g++-64 217 # provide a proper macx-g++-64
174 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
175 219
176 sed -e '/^CONFIG/s:app_bundle::' \ 220 sed -e '/^CONFIG/s:app_bundle::' \
177 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
178 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
179 fi 223 fi
180 224
181 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
182 skip_qmake_build_patch 226 skip_qmake_build
183 skip_project_generation_patch 227 skip_project_generation
184 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
185 fi 229 fi
186 230
187 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
188 # qmake bus errors with -O2 but -O3 works 232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
189 replace-flags -O2 -O3 234 replace-flags -O[23] -O1
190 fi 235 fi
191 236
192 # Bug 178652 237 # Bug 178652
193 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
194 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
195 append-flags -fno-gcse 240 append-flags -fno-gcse
196 fi 241 fi
197 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
198 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
199 if [[ $(gcc-major-version) -lt 4 ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
200 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
201 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
202 # Bug 253127 258 # Bug 253127
203 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
204 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
205 fi 261 fi
206 262
207 # Bug 261632 263 # Bug 261632
208 if use ppc64; then 264 if use ppc64; then
209 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
210 append-flags -mminimal-toc 266 append-flags -mminimal-toc
211 fi 267 fi
212 268
213 # Bug 282984 && Bug 295530 269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
214 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 270 sed -e "/^SYSTEM_VARIABLES=/i \
215 -i configure || die "sed qmake compilers failed" 271 CC='$(tc-getCC)'\n\
216 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):" \ 272 CXX='$(tc-getCXX)'\n\
217 -i config.tests/unix/compile.test || die "sed test compilers failed" 273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
218 288
219 # Bug 172219 289 # Bug 172219
220 sed -e "s:X11R6/::" \ 290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
221 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
222 291
223 if [[ ${CHOST} == *-darwin* ]]; then 292 if [[ ${CHOST} == *-darwin* ]]; then
224 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
225 # crippled (by design) :/ 294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
226 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
229 -e "s:-arch\s\w*::g" \ 309 -e "s:-arch\s\w*::g" \
230 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
231 312
232 # Fix configure's -arch settings that appear in qmake/Makefile and also 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
233 # fix arch handling (automagically duplicates our -arch arg and breaks 314 # fix arch handling (automagically duplicates our -arch arg and breaks
234 # pch). Additionally disable Xarch support. 315 # pch). Additionally disable Xarch support.
316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
235 sed \ 320 sed \
236 -e "s:-arch i386::" \ 321 -e "s:-arch i386::" \
237 -e "s:-arch ppc::" \ 322 -e "s:-arch ppc::" \
238 -e "s:-arch x86_64::" \ 323 -e "s:-arch x86_64::" \
239 -e "s:-arch ppc64::" \ 324 -e "s:-arch ppc64::" \
240 -e "s:-arch \$i::" \ 325 -e "s:-arch \$i::" \
241 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
242 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
243 -e "s:-Xarch_x86_64::g" \ 328 -e "s:-Xarch_x86_64::g" \
244 -e "s:-Xarch_ppc64::g" \ 329 -e "s:-Xarch_ppc64::g" \
245 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
246 332
247 # On Snow Leopard don't fall back to 10.5 deployment target. 333 # On Snow Leopard don't fall back to 10.5 deployment target.
248 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
249 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
250 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
252 fi 339 fi
253 fi 340 fi
254 341
255 # this one is needed for all systems with a separate -liconv, apart from 342 # this one is needed for all systems with a separate -liconv, apart from
256 # Darwin, for which the sources already cater for -liconv 343 # Darwin, for which the sources already cater for -liconv
257 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
258 sed \ 345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
259 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
260 -i config.tests/unix/iconv/iconv.pro \ 346 -i config.tests/unix/iconv/iconv.pro \
261 || die "sed on iconv.pro failed" 347 || die "sed iconv.pro failed"
262 fi 348 fi
263 349
264 # we need some patches for Solaris 350 # we need some patches for Solaris
265 sed -i \
266 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
267 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
268 # use GCC over SunStudio 353 # use GCC over SunStudio
269 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
270 # don't flirt with non-Prefix stuff, we're quite possessive 355 # do not flirt with non-Prefix stuff, we're quite possessive
271 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
272 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
273 358
274 base_src_prepare 359 base_src_prepare
275} 360}
277# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
278# @DESCRIPTION: 363# @DESCRIPTION:
279# Default configure phase 364# Default configure phase
280qt4-build_src_configure() { 365qt4-build_src_configure() {
281 setqtenv 366 setqtenv
282 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
283 426
284 # this one is needed for all systems with a separate -liconv, apart from 427 # this one is needed for all systems with a separate -liconv, apart from
285 # Darwin, for which the sources already cater for -liconv 428 # Darwin, for which the sources already cater for -liconv
286 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
287 myconf+=" -liconv" 430 conf+=" -liconv"
431 fi
288 432
289 if has glib ${IUSE//+} && use glib; then 433 if use_if_iuse glib; then
290 # use -I, -L and -l from configure
291 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
292 # avoid the -pthread argument 435 # avoid the -pthread argument
293 myconf+=" ${glibflags//-pthread}" 436 conf+=" ${glibflags//-pthread}"
294 unset glibflags 437 unset glibflags
295 fi 438 fi
296 439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi
448
297 if use aqua ; then 449 if use aqua; then
298 # On (snow) leopard use the new (frameworked) cocoa code. 450 # On (snow) leopard use the new (frameworked) cocoa code.
299 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
300 myconf+=" -cocoa -framework" 452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
301 457
302 # We are crazy and build cocoa + qt3support :-) 458 # We are crazy and build cocoa + qt3support :-)
303 if use qt3support; then 459 if use qt3support; then
304 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
305 -i configure 461 -i configure || die
306 fi 462 fi
307 463 else
308 # We need the source's headers, not the installed ones. 464 conf+=" -no-framework"
309 myconf+=" -I${S}/include"
310
311 # Add hint for the framework location.
312 myconf+=" -F${QTLIBDIR}"
313 fi 465 fi
314 else 466 else
315 # freetype2 include dir is non-standard, thus include it on configure 467 # freetype2 include dir is non-standard, thus pass it to configure
316 # use -I from configure
317 myconf+=" $(pkg-config --cflags freetype2)" 468 conf+=" $(pkg-config --cflags-only-I freetype2)"
318 fi 469 fi
319 470
471 conf+=" ${myconf}"
472 myconf=
473
320 echo ./configure ${myconf} 474 echo ./configure ${conf}
321 ./configure ${myconf} || die "./configure failed" 475 ./configure ${conf} || die "./configure failed"
322 myconf="" 476
477 prepare_directories ${QT4_TARGET_DIRECTORIES}
323} 478}
324 479
325# @FUNCTION: qt4-build_src_compile 480# @FUNCTION: qt4-build_src_compile
481# @DESCRIPTION:
326# @DESCRIPTION: Actual compile phase 482# Actual compile phase
327qt4-build_src_compile() { 483qt4-build_src_compile() {
328 setqtenv 484 setqtenv
329 485
330 build_directories ${QT4_TARGET_DIRECTORIES} 486 build_directories ${QT4_TARGET_DIRECTORIES}
331} 487}
332 488
489# @FUNCTION: qt4-build_src_test
490# @DESCRIPTION:
491# Runs tests only in target directories.
492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
496 for dir in ${QT4_TARGET_DIRECTORIES}; do
497 emake -j1 check -C ${dir}
498 done
499}
500
333# @FUNCTION: fix_includes 501# @FUNCTION: fix_includes
334# @DESCRIPTION: 502# @DESCRIPTION:
335# For MacOSX we need to add some symlinks when frameworks are 503# For MacOS X we need to add some symlinks when frameworks are
336# being used, to avoid complications with some more or less stupid packages. 504# being used, to avoid complications with some more or less stupid packages.
337fix_includes() { 505fix_includes() {
338 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
507 local frw dest f h rdir
339 # Some packages tend to include <Qt/...> 508 # Some packages tend to include <Qt/...>
340 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 509 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
341 510
342 # Fake normal headers when frameworks are installed... eases life later on 511 # Fake normal headers when frameworks are installed... eases life later
343 local dest f 512 # on, make sure we use relative links though, as some ebuilds assume
513 # these dirs exist in src_install to add additional files
514 f=${QTHEADERDIR}
515 h=${QTLIBDIR}
516 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
517 f=${f#*/}
518 h=${h#*/}
519 done
520 rdir=${h}
521 f="../"
522 while [[ ${h} == */* ]] ; do
523 f="${f}../"
524 h=${h#*/}
525 done
526 rdir="${f}${rdir}"
527
344 for frw in "${D}${QTLIBDIR}"/*.framework; do 528 for frw in "${D}${QTLIBDIR}"/*.framework; do
345 [[ -e "${frw}"/Headers ]] || continue 529 [[ -e "${frw}"/Headers ]] || continue
346 f=$(basename ${frw}) 530 f=$(basename ${frw})
347 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 531 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
348 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 532 dosym "${rdir}"/${f}/Headers "${dest}"
349 533
350 # Link normal headers as well. 534 # Link normal headers as well.
351 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 535 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
352 h=$(basename ${hdr}) 536 h=$(basename ${hdr})
353 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 537 dosym "../${rdir}"/${f}/Headers/${h} \
538 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
354 done 539 done
355 done 540 done
356 fi 541 fi
357} 542}
358 543
360# @DESCRIPTION: 545# @DESCRIPTION:
361# Perform the actual installation including some library fixes. 546# Perform the actual installation including some library fixes.
362qt4-build_src_install() { 547qt4-build_src_install() {
363 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 548 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
364 setqtenv 549 setqtenv
550
365 install_directories ${QT4_TARGET_DIRECTORIES} 551 install_directories ${QT4_TARGET_DIRECTORIES}
366 install_qconfigs 552 install_qconfigs
367 fix_library_files 553 fix_library_files
368 fix_includes 554 fix_includes
555
556 # remove .la files since we are building only shared Qt libraries
557 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
369} 558}
370 559
371# @FUNCTION: setqtenv 560# @FUNCTION: setqtenv
561# @INTERNAL
372setqtenv() { 562setqtenv() {
373 # Set up installation directories 563 # Set up installation directories
374 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
375 QTPREFIXDIR=${EPREFIX}/usr 564 QTPREFIXDIR=${EPREFIX}/usr
376 QTBINDIR=${EPREFIX}/usr/bin 565 QTBINDIR=${EPREFIX}/usr/bin
377 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 566 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
378 QMAKE_LIBDIR_QT=${QTLIBDIR}
379 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 567 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
380 QTDATADIR=${EPREFIX}/usr/share/qt4
381 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 568 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
382 QTHEADERDIR=${EPREFIX}/usr/include/qt4 569 QTHEADERDIR=${EPREFIX}/usr/include/qt4
383 QTPLUGINDIR=${QTLIBDIR}/plugins 570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${EPREFIX}/usr/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
384 QTSYSCONFDIR=${EPREFIX}/etc/qt4 574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
385 QTTRANSDIR=${QTDATADIR}/translations
386 QTEXAMPLESDIR=${QTDATADIR}/examples 575 QTEXAMPLESDIR=${QTDATADIR}/examples
387 QTDEMOSDIR=${QTDATADIR}/demos 576 QTDEMOSDIR=${QTDATADIR}/demos
577 QMAKE_LIBDIR_QT=${QTLIBDIR}
388 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 578 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
579
389 PLATFORM=$(qt_mkspecs_dir) 580 PLATFORM=$(qt_mkspecs_dir)
390 581
391 unset QMAKESPEC 582 unset QMAKESPEC
392} 583}
393 584
394# @FUNCTION: standard_configure_options
395# @DESCRIPTION:
396# Sets up some standard configure options, like libdir (if necessary), whether
397# debug info is wanted or not.
398standard_configure_options() {
399 local myconf=
400
401 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # Disable visibility explicitly if gcc version isn't 4
404 if [[ $(gcc-major-version) -lt 4 ]]; then
405 myconf+=" -no-reduce-exports"
406 fi
407
408 # precompiled headers doesn't work on hardened, where the flag is masked.
409 myconf+=" $(qt_use pch)"
410
411 if use debug; then
412 myconf+=" -debug"
413 else
414 myconf+=" -release"
415 fi
416 myconf+=" -no-separate-debug-info"
417
418 use aqua && myconf+=" -no-framework"
419
420 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
421 # $(tc-arch). Therefore we convert it to supported values.
422 case "$(tc-arch)" in
423 amd64|x64-*) myconf+=" -arch x86_64" ;;
424 ppc-macos) myconf+=" -arch ppc" ;;
425 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
426 sparc|sparc-*) myconf+=" -arch sparc" ;;
427 x86-macos) myconf+=" -arch x86" ;;
428 x86|x86-*) myconf+=" -arch i386" ;;
429 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
430 hppa|sh) myconf+=" -arch generic" ;;
431 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
432 esac
433
434 # 4.5: build everything but qt-xmlpatterns w/o exceptions
435 # 4.6: exceptions USE flag
436 local exceptions="-exceptions"
437 case "${PV}" in
438 4.5.*)
439 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
440 ;;
441 *)
442 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
443 ;;
444 esac
445
446 # note about -reduce-relocations:
447 # That flag seems to introduce major breakage to applications,
448 # mostly to be seen as a core dump with the message "QPixmap: Must
449 # construct a QApplication before a QPaintDevice" on Solaris
450 # -- Daniel Vergien
451 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
452
453 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
454 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
455 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
456 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
457 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
458 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
459 ${exceptions}
460 -nomake examples -nomake demos"
461
462 echo "${myconf}"
463}
464
465# @FUNCTION: build_directories 585# @FUNCTION: prepare_directories
466# @USAGE: < directories > 586# @USAGE: < directories >
587# @INTERNAL
467# @DESCRIPTION: 588# @DESCRIPTION:
468# Compiles the code in $QT4_TARGET_DIRECTORIES 589# Generates Makefiles for the given list of directories.
469build_directories() { 590prepare_directories() {
470 for x in "$@"; do 591 for x in "$@"; do
471 pushd "${S}"/${x} >/dev/null 592 pushd "${S}"/${x} >/dev/null || die
593 einfo "Running qmake in: ${x}"
472 # avoid running over the maximum argument number, bug #299810 594 # avoid running over the maximum argument number, bug #299810
473 { 595 {
474 echo "${S}"/mkspecs/common/*.conf 596 echo "${S}"/mkspecs/common/*.conf
475 find "${S}" -name '*.pr[io]' 597 find "${S}" -name '*.pr[io]'
476 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 598 } | xargs sed -i \
599 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
600 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
601 || die
477 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 602 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
603 popd >/dev/null || die
604 done
605}
606
607
608# @FUNCTION: build_directories
609# @USAGE: < directories >
610# @INTERNAL
611# @DESCRIPTION:
612# Compiles the code in the given list of directories.
613build_directories() {
614 for x in "$@"; do
615 pushd "${S}"/${x} >/dev/null || die
478 emake CC="$(tc-getCC)" \ 616 emake CC="$(tc-getCC)" \
479 CXX="$(tc-getCXX)" \ 617 CXX="$(tc-getCXX)" \
480 LINK="$(tc-getCXX)" || die "emake failed" 618 LINK="$(tc-getCXX)" || die "emake failed"
481 popd >/dev/null 619 popd >/dev/null || die
482 done 620 done
483} 621}
484 622
485# @FUNCTION: install_directories 623# @FUNCTION: install_directories
486# @USAGE: < directories > 624# @USAGE: < directories >
625# @INTERNAL
487# @DESCRIPTION: 626# @DESCRIPTION:
488# run emake install in the given directories, which are separated by spaces 627# Runs emake install in the given directories, which are separated by spaces.
489install_directories() { 628install_directories() {
490 for x in "$@"; do 629 for x in "$@"; do
491 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 630 pushd "${S}"/${x} >/dev/null || die
492 emake INSTALL_ROOT="${D}" install || die "emake install failed" 631 emake INSTALL_ROOT="${D}" install || die "emake install failed"
493 popd >/dev/null || die "Can't popd from ${S}/${x}" 632 popd >/dev/null || die
494 done 633 done
495} 634}
496 635
497# @ECLASS-VARIABLE: QCONFIG_ADD 636# @ECLASS-VARIABLE: QCONFIG_ADD
498# @DESCRIPTION: 637# @DESCRIPTION:
508# @DESCRIPTION: 647# @DESCRIPTION:
509# List variables that should be defined at the top of QtCore/qconfig.h 648# List variables that should be defined at the top of QtCore/qconfig.h
510: ${QCONFIG_DEFINE:=} 649: ${QCONFIG_DEFINE:=}
511 650
512# @FUNCTION: install_qconfigs 651# @FUNCTION: install_qconfigs
652# @INTERNAL
653# @DESCRIPTION:
513# @DESCRIPTION: Install gentoo-specific mkspecs configurations 654# Install gentoo-specific mkspecs configurations.
514install_qconfigs() { 655install_qconfigs() {
515 local x 656 local x
516 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 657 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
517 for x in QCONFIG_ADD QCONFIG_REMOVE; do 658 for x in QCONFIG_ADD QCONFIG_REMOVE; do
518 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 659 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
529 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 670 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
530 fi 671 fi
531} 672}
532 673
533# @FUNCTION: generate_qconfigs 674# @FUNCTION: generate_qconfigs
534# @DESCRIPTION: Generates gentoo-specific configurations 675# @INTERNAL
676# @DESCRIPTION:
677# Generates gentoo-specific qconfig.{h,pri}.
535generate_qconfigs() { 678generate_qconfigs() {
536 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
537 local x qconfig_add qconfig_remove qconfig_new 680 local x qconfig_add qconfig_remove qconfig_new
538 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
539 [[ -f ${x} ]] || continue 682 [[ -f ${x} ]] || continue
540 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
541 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
553 696
554 # generate list of QT_CONFIG entries from the existing list 697 # generate list of QT_CONFIG entries from the existing list
555 # including qconfig_add and excluding qconfig_remove 698 # including qconfig_add and excluding qconfig_remove
556 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 699 for x in $(sed -n 's/^QT_CONFIG +=//p' \
557 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 700 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
558 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 701 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
559 done 702 done
560 703
561 # replace the existing QT_CONFIG list with qconfig_new 704 # replace the existing QT_CONFIG list with qconfig_new
562 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 705 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
563 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 706 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
587 fi 730 fi
588 fi 731 fi
589} 732}
590 733
591# @FUNCTION: qt4-build_pkg_postrm 734# @FUNCTION: qt4-build_pkg_postrm
735# @DESCRIPTION:
592# @DESCRIPTION: Generate configurations when the package is completely removed 736# Regenerate configuration when the package is completely removed.
593qt4-build_pkg_postrm() { 737qt4-build_pkg_postrm() {
594 generate_qconfigs 738 generate_qconfigs
595} 739}
596 740
597# @FUNCTION: qt4-build_pkg_postinst 741# @FUNCTION: qt4-build_pkg_postinst
742# @DESCRIPTION:
598# @DESCRIPTION: Generate configuration, plus throws a message about possible 743# Regenerate configuration, plus throw a message about possible
599# breakages and proposed solutions. 744# breakages and proposed solutions.
600qt4-build_pkg_postinst() { 745qt4-build_pkg_postinst() {
601 generate_qconfigs 746 generate_qconfigs
602} 747}
603 748
604# @FUNCTION: skip_qmake_build_patch 749# @FUNCTION: skip_qmake_build
750# @INTERNAL
605# @DESCRIPTION: 751# @DESCRIPTION:
606# Don't need to build qmake, as it's already installed from qt-core 752# Patches configure to skip qmake compilation, as it's already installed by qt-core.
607skip_qmake_build_patch() { 753skip_qmake_build() {
608 # Don't need to build qmake, as it's already installed from qt-core
609 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 754 sed -i -e "s:if true:if false:g" "${S}"/configure || die
610} 755}
611 756
612# @FUNCTION: skip_project_generation_patch 757# @FUNCTION: skip_project_generation
758# @INTERNAL
613# @DESCRIPTION: 759# @DESCRIPTION:
614# Exit the script early by throwing in an exit before all of the .pro files are scanned 760# Exit the script early by throwing in an exit before all of the .pro files are scanned.
615skip_project_generation_patch() { 761skip_project_generation() {
616 # Exit the script early by throwing in an exit before all of the .pro files are scanned
617 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 762 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
618 -i "${S}"/configure || die "Sed failed"
619} 763}
620 764
621# @FUNCTION: symlink_binaries_to_buildtree 765# @FUNCTION: symlink_binaries_to_buildtree
766# @INTERNAL
622# @DESCRIPTION: 767# @DESCRIPTION:
623# Symlink generated binaries to buildtree so they can be used during compilation 768# Symlinks generated binaries to buildtree, so they can be used during compilation time.
624# time
625symlink_binaries_to_buildtree() { 769symlink_binaries_to_buildtree() {
626 for bin in qmake moc uic rcc; do 770 for bin in qmake moc uic rcc; do
627 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 771 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
628 done 772 done
629} 773}
630 774
631# @FUNCTION: fix_library_files 775# @FUNCTION: fix_library_files
776# @INTERNAL
632# @DESCRIPTION: 777# @DESCRIPTION:
633# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 778# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
634# moves the *.pc-files into the pkgconfig directory 779# moves the *.pc files into the pkgconfig directory.
635fix_library_files() { 780fix_library_files() {
781 local libfile
636 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 782 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
637 if [[ -e ${libfile} ]]; then 783 if [[ -e ${libfile} ]]; then
638 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 784 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
639 fi 785 fi
640 done 786 done
641 787
642 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 788 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
643 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 789 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
644 if [[ -e ${libfile} ]]; then 790 if [[ -e ${libfile} ]]; then
645 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 791 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
646 792
647 # Move .pc files into the pkgconfig directory 793 # Move .pc files into the pkgconfig directory
648 dodir ${QTPCDIR#${EPREFIX}} 794 dodir ${QTPCDIR#${EPREFIX}}
649 mv ${libfile} "${D}"/${QTPCDIR}/ \ 795 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
650 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
651 fi 796 fi
652 done 797 done
653 798
654 # Don't install an empty directory 799 # Don't install an empty directory
655 rmdir "${D}"/${QTLIBDIR}/pkgconfig 800 rmdir "${D}"/${QTLIBDIR}/pkgconfig
656} 801}
657 802
658# @FUNCTION: qt_use 803# @FUNCTION: qt_use
659# @USAGE: < flag > [ feature ] [ enableval ] 804# @USAGE: < flag > [ feature ] [ enableval ]
660# @DESCRIPTION: 805# @DESCRIPTION:
661# This will echo "${enableval}-${feature}" if <flag> is enabled, or 806# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
662# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 807# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
663# will be used for that. If [enableval] is not specified, it omits the 808# will be used for that. If [enableval] is not specified, it omits the
664# assignment-part 809# "-${enableval}" part.
665qt_use() { 810qt_use() {
666 local flag=$1 811 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
667 local feature=$1
668 local enableval=
669
670 [[ -n $2 ]] && feature=$2
671 [[ -n $3 ]] && enableval=-$3
672
673 if use ${flag}; then
674 echo "${enableval}-${feature}"
675 else
676 echo "-no-${feature}"
677 fi
678} 812}
679 813
680# @FUNCTION: qt_mkspecs_dir 814# @FUNCTION: qt_mkspecs_dir
681# @RETURN: the specs-directory w/o path 815# @RETURN: the specs-directory w/o path
682# @DESCRIPTION: 816# @DESCRIPTION:
683# Allows us to define which mkspecs dir we want to use. 817# Allows us to define which mkspecs dir we want to use.
684qt_mkspecs_dir() { 818qt_mkspecs_dir() {
685 # Allows us to define which mkspecs dir we want to use.
686 local spec 819 local spec=
687 820
688 case ${CHOST} in 821 case "${CHOST}" in
689 *-freebsd*|*-dragonfly*) 822 *-freebsd*|*-dragonfly*)
690 spec=freebsd ;; 823 spec=freebsd ;;
691 *-openbsd*) 824 *-openbsd*)
692 spec=openbsd ;; 825 spec=openbsd ;;
693 *-netbsd*) 826 *-netbsd*)
704 *-solaris*) 837 *-solaris*)
705 spec=solaris ;; 838 spec=solaris ;;
706 *-linux-*|*-linux) 839 *-linux-*|*-linux)
707 spec=linux ;; 840 spec=linux ;;
708 *) 841 *)
709 die "Unknown CHOST, no platform choosen." 842 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
710 esac 843 esac
711 844
712 CXX=$(tc-getCXX) 845 case "$(tc-getCXX)" in
713 if [[ ${CXX} == *g++* ]]; then 846 *g++*)
714 spec+=-g++ 847 spec+=-g++ ;;
715 elif [[ ${CXX} == *icpc* ]]; then 848 *icpc*)
716 spec+=-icc 849 spec+=-icc ;;
717 else 850 *)
718 die "Unknown compiler ${CXX}." 851 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
719 fi 852 esac
720 if [[ -n ${LIBDIR/lib} ]]; then
721 spec+=-${LIBDIR/lib}
722 fi
723 853
724 # Add -64 for 64bit profiles 854 # Add -64 for 64bit profiles
725 if use x64-freebsd || 855 if use x64-freebsd ||
726 use amd64-linux || 856 use amd64-linux ||
727 use x64-macos || 857 use x64-macos ||
732 fi 862 fi
733 863
734 echo "${spec}" 864 echo "${spec}"
735} 865}
736 866
867# @FUNCTION: qt_assistant_cleanup
868# @INTERNAL
869# @DESCRIPTION:
870# Tries to clean up tools.pro for qt-assistant ebuilds.
871# Meant to be called in src_prepare().
872# Since Qt 4.7.4 this function is a no-op.
873qt_assistant_cleanup() {
874 # apply patching to qt-assistant ebuilds only
875 [[ ${PN} != qt-assistant ]] && return
876
877 # no longer needed for 4.7.4 and later
878 version_is_at_least 4.7.4 && return
879
880 # different versions (and branches...) may need different handling,
881 # add a case if you need special handling
882 case "${MY_PV_EXTRA}" in
883 *kde-qt*)
884 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
885 -e "/mac/,/^embedded.*makeqpf$/d" \
886 -i tools/tools.pro || die "patching tools.pro failed"
887 ;;
888 *)
889 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
890 -e "/mac/,/^embedded.*makeqpf$/d" \
891 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
892 -i tools/tools.pro || die "patching tools.pro failed"
893 ;;
894 esac
895}
896
897# @FUNCTION: qt_nolibx11
898# @INTERNAL
899# @DESCRIPTION:
900# Ignore X11 tests for packages that don't need X libraries installed.
901qt_nolibx11() {
902 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
903 die "x11 check sed failed"
904}
905
737EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 906EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.69  
changed lines
  Added in v.1.127

  ViewVC Help
Powered by ViewVC 1.1.20